// *********************
// ** Fichier Include **
// *********************

#include "header/SMSlib.h" 

// *******************
// ** Header Custom **
// *******************
SMS_EMBED_SEGA_ROM_HEADER(0,0);
SMS_EMBED_SDSC_HEADER(1,0,2018,03,01,"Monos","Test","Toto") ;

// *******************
// ** Tiles de test **
// *******************
const unsigned char tilesb[] = {

	0b11111111,
	0b10000001,
	0b10000001,
	0b10000001,
	0b10000001,
	0b10000001,
	0b10000001,
	0b11111111,

};

//	*****************
//  ** Boucle main **
//	*****************
void main () 
{ 
	// -------------------------------
	// -- Déclaration des variables --
	// -------------------------------
	unsigned char cy;
	unsigned char cx;
	unsigned char px;
	unsigned char py;
	
	// ------------------------
	// -- Position du sprite --
	// ------------------------
	px=100;
	py=100;
	
	// ----------------------------------------------------------
	// -- Chargement du tiles dans le VDP des tiles et sprites --
	// ----------------------------------------------------------
	SMS_load1bppTiles (tilesb,256,32, 0, 1);
	SMS_load1bppTiles (tilesb,16,32, 0, 1);
	
	// ----------------------------------------------
	// -- Mise en mémoire de la palette de couleur --
	// ----------------------------------------------
	SMS_setBGPaletteColor (0, RGB(0,0,0) );
	SMS_setBGPaletteColor (1, RGB(2,3,2) );
	SMS_setSpritePaletteColor (0, RGB(0,2,0) );
	SMS_setSpritePaletteColor (1, RGBHTML(0xFF0000) );
	
	
	// -------------------------------------
	// -- Affichage d'une grille de tiles --
	// -------------------------------------
	for(cy=0;cy<9;cy++)
	{
		for(cx=0;cx<9;cx++)
		{
		 SMS_setTileatXY( cx+10,cy,16);
		}
	}	
	
	// -- Activation de l'écran --
	SMS_displayOn();
	
	// ------------
	// -- Boucle --
	// ------------
	while(1)
	{
		// ----------------------
		// -- Gestion du pad A --
		// ----------------------
		if (SMS_getKeysStatus ()& PORT_A_KEY_RIGHT  )
		{
			px++;
		}
		
			if (SMS_getKeysStatus ()& PORT_A_KEY_LEFT  )
		{
			px--;
		}
		
			if (SMS_getKeysStatus ()& PORT_A_KEY_UP  )
		{
			py--;
		}
		
			if (SMS_getKeysStatus ()& PORT_A_KEY_DOWN  )
		{
			py++;
		}

		// ------------------------
		// -- Gestion de l'écran --
		// ------------------------
		SMS_initSprites ();		
		SMS_addSprite (px, py, 256);	
		SMS_finalizeSprites();
		SMS_waitForVBlank();
		SMS_copySpritestoSAT();	
	}
}